/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.PendidikanDao;
import com.portofolio.dto.PendidikanDto;
import com.portofolio.entity.Pendidikan;
import com.portofolio.entity.vo.PendidikanId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class PendidikanService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private PendidikanDao pendidikanDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(PendidikanDto pendidikanDto) {
		result.clear();
		PendidikanId id = new PendidikanId();
		String kdPendidikan =getIdTerahir(Pendidikan.class.getSimpleName(), 2);
		id.setKdPendidikan(kdPendidikan);
		id.setKdProfile(getKdProfile());
		Pendidikan pendidikan = CommonUtil.findOne(pendidikanDao, id);
		if (CommonUtil.isNullOrEmpty(pendidikan)) {
			pendidikan = new Pendidikan();
			BeanUtils.copyProperties(pendidikanDto, pendidikan);
			pendidikan.setNoRec(generateUuid32());
			pendidikan.setVersion(1);
			pendidikan.setId(id);
			pendidikan = pendidikanDao.save(pendidikan);
			result.put("pendidikan", pendidikan);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("pendidikan.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(PendidikanDto pendidikanDto, String kdPendidikan, Integer version) {
		result.clear();
		PendidikanId id = new PendidikanId();
		id.setKdPendidikan(kdPendidikan);
		id.setKdProfile(getKdProfile());
		Pendidikan pendidikan = CommonUtil.findOne(pendidikanDao, id);
		if (CommonUtil.isNotNullOrEmpty(pendidikan)) {
			if (version < pendidikan.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(pendidikanDto, pendidikan);
			pendidikan.setVersion(version);
			pendidikan = pendidikanDao.save(pendidikan);
			result.put("pendidikan", pendidikan);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaPendidikan,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaPendidikan)) {
			pageRes = pendidikanDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = pendidikanDao.findAllList(getKdProfile(), namaPendidikan, statusEnabled, pageReq);
		}
		result.put("pendidikan", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdPendidikan(String kdPendidikan) {
		result.clear();
		result.put("pendidikan", pendidikanDao.findByKdPendidikan(getKdProfile(), kdPendidikan, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(String kdPendidikan, Integer version) {
		result.clear();
		PendidikanId id = new PendidikanId();
		id.setKdPendidikan(kdPendidikan);
		id.setKdProfile(getKdProfile());
		Pendidikan pendidikan = CommonUtil.findOne(pendidikanDao, id);
		if (CommonUtil.isNotNullOrEmpty(pendidikan)) {
			if (version < pendidikan.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			pendidikan.setStatusEnabled(false);
			pendidikan.setVersion(version);
			pendidikan = pendidikanDao.save(pendidikan);
			result.put("pendidikan", pendidikan);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
